
/////////////////////////////////////////////////////////////
//
// Source file for GeneralOptionsFormUI
//
//    This class implements the user interface created in 
//    RapidApp.
//
//    Restrict changes to those sections between
//    the "//--- Start/End editable code block" markers
//
//    This will allow RapidApp to integrate changes more easily
//
//    This class is a ViewKit user interface "component".
//    For more information on how components are used, see the
//    "ViewKit Programmers' Manual", and the RapidApp
//    User's Guide.
//
//
/////////////////////////////////////////////////////////////


#include "GeneralOptionsFormUI.h" // Generated header file for this class

#include <Xm/Form.h> 
#include <Vk/VkResource.h>
#include <Vk/VkOptionMenu.h>
#include <Vk/VkMenuItem.h>
//---- Start editable code block: headers and declarations


//---- End editable code block: headers and declarations



// These are default resources for widgets in objects of this class
// All resources will be prepended by *<name> at instantiation,
// where <name> is the name of the specific instance, as well as the
// name of the baseWidget. These are only defaults, and may be overriden
// in a resource file by providing a more specific resource name

String  GeneralOptionsFormUI::_defaultGeneralOptionsFormUIResources[] = {
        "*connectionMenu.labelString:  Connection:",
        "*isdn1Button.labelString:  ISDN-1",
        "*isdn2Button.labelString:  ISDN-2",
        "*lanButton.labelString:  LAN",
        "*modemButton.labelString:  Modem 28.8",
        "*tabLabel:  General",

        //---- Start editable code block: GeneralOptionsFormUI Default Resources


        //---- End editable code block: GeneralOptionsFormUI Default Resources

        (char*)NULL
};

GeneralOptionsFormUI::GeneralOptionsFormUI ( const char *name ) : VkComponent ( name ) 
{ 
    // No widgets are created by this constructor.
    // If an application creates a component using this constructor,
    // It must explictly call create at a later time.
    // This is mostly useful when adding pre-widget creation
    // code to a derived class constructor.

    //---- Start editable code block: GeneralOptionsForm constructor 2


    //---- End editable code block: GeneralOptionsForm constructor 2


}    // End Constructor




GeneralOptionsFormUI::GeneralOptionsFormUI ( const char *name, Widget parent ) : VkComponent ( name ) 
{ 
    //---- Start editable code block: GeneralOptionsForm pre-create


    //---- End editable code block: GeneralOptionsForm pre-create



    // Call creation function to build the widget tree.

     create ( parent );

    //---- Start editable code block: GeneralOptionsForm constructor


    //---- End editable code block: GeneralOptionsForm constructor


}    // End Constructor


GeneralOptionsFormUI::~GeneralOptionsFormUI() 
{
    // Base class destroys widgets

    //---- Start editable code block: GeneralOptionsFormUI destructor


    //---- End editable code block: GeneralOptionsFormUI destructor
}    // End destructor



void GeneralOptionsFormUI::create ( Widget parent )
{
    Arg      args[12];
    Cardinal count;
    count = 0;

    // Load any class-defaulted resources for this object

    setDefaultResources ( parent, _defaultGeneralOptionsFormUIResources  );


    // Create an unmanaged widget as the top of the widget hierarchy

    _baseWidget = _generalOptionsForm = XtVaCreateWidget ( _name,
                                                           xmFormWidgetClass,
                                                           parent, 
                                                           XmNresizePolicy, XmRESIZE_GROW, 
                                                           (XtPointer) NULL ); 

    // install a callback to guard against unexpected widget destruction

    installDestroyHandler();


    // Create widgets used in this component
    // All variables are data members of this class

    _connectionMenu = new VkOptionMenu ( _baseWidget, "connectionMenu");
    _modemButton =  _connectionMenu->addAction ( "modemButton", 
                                                 &GeneralOptionsFormUI::modemCallback, 
                                                 (XtPointer) this );

    _isdn1Button =  _connectionMenu->addAction ( "isdn1Button", 
                                                 &GeneralOptionsFormUI::ISDN1Callback, 
                                                 (XtPointer) this );

    _isdn2Button =  _connectionMenu->addAction ( "isdn2Button", 
                                                 &GeneralOptionsFormUI::ISDN2Callback, 
                                                 (XtPointer) this );

    _lanButton =  _connectionMenu->addAction ( "lanButton", 
                                               &GeneralOptionsFormUI::LANCallback, 
                                               (XtPointer) this );

    XtVaSetValues ( _connectionMenu->baseWidget(),
                    XmNtopAttachment, XmATTACH_FORM, 
                    XmNbottomAttachment, XmATTACH_NONE, 
                    XmNleftAttachment, XmATTACH_FORM, 
                    XmNrightAttachment, XmATTACH_NONE, 
                    XmNtopOffset, 120, 
                    XmNbottomOffset, 0, 
                    XmNleftOffset, 20, 
                    XmNrightOffset, 0, 
                    XmNwidth, 230, 
                    XmNheight, 32, 
                    (XtPointer) NULL );

    //---- Start editable code block: GeneralOptionsFormUI create


    //---- End editable code block: GeneralOptionsFormUI create
}

const char * GeneralOptionsFormUI::className()
{
    return ("GeneralOptionsFormUI");
}    // End className()




/////////////////////////////////////////////////////////////// 
// The following functions are static member functions used to 
// interface with Motif.
/////////////////////////////////// 

void GeneralOptionsFormUI::ISDN1Callback ( Widget    w,
                                           XtPointer clientData,
                                           XtPointer callData ) 
{ 
    GeneralOptionsFormUI* obj = ( GeneralOptionsFormUI * ) clientData;
    obj->ISDN1 ( w, callData );
}

void GeneralOptionsFormUI::ISDN2Callback ( Widget    w,
                                           XtPointer clientData,
                                           XtPointer callData ) 
{ 
    GeneralOptionsFormUI* obj = ( GeneralOptionsFormUI * ) clientData;
    obj->ISDN2 ( w, callData );
}

void GeneralOptionsFormUI::LANCallback ( Widget    w,
                                         XtPointer clientData,
                                         XtPointer callData ) 
{ 
    GeneralOptionsFormUI* obj = ( GeneralOptionsFormUI * ) clientData;
    obj->LAN ( w, callData );
}

void GeneralOptionsFormUI::modemCallback ( Widget    w,
                                           XtPointer clientData,
                                           XtPointer callData ) 
{ 
    GeneralOptionsFormUI* obj = ( GeneralOptionsFormUI * ) clientData;
    obj->modem ( w, callData );
}



/////////////////////////////////////////////////////////////// 
// The following functions are called from the menu items 
// in this window.
/////////////////////////////////// 

void GeneralOptionsFormUI::ISDN1 ( Widget, XtPointer ) 
{
    // This virtual function is called from ISDN1Callback.
    // This function is normally overriden by a derived class.

}

void GeneralOptionsFormUI::ISDN2 ( Widget, XtPointer ) 
{
    // This virtual function is called from ISDN2Callback.
    // This function is normally overriden by a derived class.

}

void GeneralOptionsFormUI::LAN ( Widget, XtPointer ) 
{
    // This virtual function is called from LANCallback.
    // This function is normally overriden by a derived class.

}

void GeneralOptionsFormUI::modem ( Widget, XtPointer ) 
{
    // This virtual function is called from modemCallback.
    // This function is normally overriden by a derived class.

}



//---- Start editable code block: End of generated code


//---- End editable code block: End of generated code
